]> git.notmuchmail.org Git - notmuch/blob - test/test-lib.sh
6f4bb47fb88c681d015f0b879f3c7b148c34f70f
[notmuch] / test / test-lib.sh
1 #
2 # Copyright (c) 2005 Junio C Hamano
3 # Copyright (c) 2010 Notmuch Developers
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program.  If not, see https://www.gnu.org/licenses/ .
17
18 if [ ${BASH_VERSINFO[0]} -lt 4 ]; then
19     echo "Error: The notmuch test suite requires a bash version >= 4.0"
20     echo "due to use of associative arrays within the test suite."
21     echo "Please try again with a newer bash (or help us fix the"
22     echo "test suite to be more portable). Thanks."
23     exit 1
24 fi
25
26 # Make sure echo builtin does not expand backslash-escape sequences by default.
27 shopt -u xpg_echo
28
29 # Ensure NOTMUCH_SRCDIR and NOTMUCH_BUILDDIR are set.
30 . $(dirname "$0")/export-dirs.sh || exit 1
31
32 # It appears that people try to run tests without building...
33 if [[ ! -x "$NOTMUCH_BUILDDIR/notmuch" ]]; then
34         echo >&2 'You do not seem to have built notmuch yet.'
35         exit 1
36 fi
37
38 this_test=${0##*/}
39 this_test=${this_test%.sh}
40 this_test_bare=${this_test#T[0-9][0-9][0-9]-}
41
42 # if --tee was passed, write the output not only to the terminal, but
43 # additionally to the file test-results/$BASENAME.out, too.
44 case "$GIT_TEST_TEE_STARTED, $* " in
45 done,*)
46         # do not redirect again
47         ;;
48 *' --tee '*|*' --va'*)
49         mkdir -p test-results
50         BASE=test-results/$this_test
51         (GIT_TEST_TEE_STARTED=done "$BASH" "$0" "$@" 2>&1;
52          echo $? > $BASE.exit) | tee $BASE.out
53         test "$(cat $BASE.exit)" = 0
54         exit
55         ;;
56 esac
57
58 # STDIN from /dev/null. EOF for readers (and ENOTTY for tty related ioctls).
59 exec </dev/null
60
61 # Save STDOUT to fd 6 and STDERR to fd 7.
62 exec 6>&1 7>&2
63 # Make xtrace debugging (when used) use redirected STDERR, with verbose lead:
64 BASH_XTRACEFD=7
65 export PS4='+(${BASH_SOURCE}:${LINENO}): ${FUNCNAME[0]:+${FUNCNAME[0]}(): }'
66
67 # Keep the original TERM for say_color and test_emacs
68 ORIGINAL_TERM=$TERM
69
70 # Set SMART_TERM to vt100 for known dumb/unknown terminal.
71 # Otherwise use whatever TERM is currently used so that
72 # users' actual TERM environments are being used in tests.
73 case ${TERM-} in
74         '' | dumb | unknown )
75                 SMART_TERM=vt100 ;;
76         *)
77                 SMART_TERM=$TERM ;;
78 esac
79
80 # For repeatability, reset the environment to known value.
81 LANG=C
82 LC_ALL=C
83 PAGER=cat
84 TZ=UTC
85 TERM=dumb
86 export LANG LC_ALL PAGER TERM TZ
87 GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
88 if [[ ( -n "$TEST_EMACS" && -z "$TEST_EMACSCLIENT" ) || \
89       ( -z "$TEST_EMACS" && -n "$TEST_EMACSCLIENT" ) ]]; then
90     echo "error: must specify both or neither of TEST_EMACS and TEST_EMACSCLIENT" >&2
91     exit 1
92 fi
93 TEST_EMACS=${TEST_EMACS:-${EMACS:-emacs}}
94 TEST_EMACSCLIENT=${TEST_EMACSCLIENT:-emacsclient}
95 TEST_GDB=${TEST_GDB:-gdb}
96 TEST_CC=${TEST_CC:-cc}
97 TEST_CFLAGS=${TEST_CFLAGS:-"-g -O0"}
98 TEST_SHIM_CFLAGS=${TEST_SHIM_CFLAGS:-"-fpic -shared"}
99 TEST_SHIM_LDFLAGS=${TEST_SHIM_LDFLAGS:-"-ldl"}
100
101 # Protect ourselves from common misconfiguration to export
102 # CDPATH into the environment
103 unset CDPATH
104
105 unset GREP_OPTIONS
106
107 # For lib/open.cc:_load_key_file
108 unset XDG_CONFIG_HOME
109
110 # For emacsclient
111 unset ALTERNATE_EDITOR
112
113 # for reproducibility
114 unset EMAIL
115 unset NAME
116
117 add_gnupg_home () {
118     [ -e "${GNUPGHOME}/gpg.conf" ] && return
119     _gnupg_exit () { gpgconf --kill all 2>/dev/null || true; }
120     at_exit_function _gnupg_exit
121     mkdir -p -m 0700 "$GNUPGHOME"
122     gpg --no-tty --import <$NOTMUCH_SRCDIR/test/gnupg-secret-key.asc >"$GNUPGHOME"/import.log 2>&1
123     test_debug "cat $GNUPGHOME/import.log"
124     if (gpg --quick-random --version >/dev/null 2>&1) ; then
125         echo quick-random >> "$GNUPGHOME"/gpg.conf
126     elif (gpg --debug-quick-random --version >/dev/null 2>&1) ; then
127         echo debug-quick-random >> "$GNUPGHOME"/gpg.conf
128     fi
129     echo no-emit-version >> "$GNUPGHOME"/gpg.conf
130
131     # Change this if we ship a new test key
132     FINGERPRINT="5AEAB11F5E33DCE875DDB75B6D92612D94E46381"
133     SELF_USERID="Notmuch Test Suite <test_suite@notmuchmail.org> (INSECURE!)"
134     SELF_EMAIL="test_suite@notmuchmail.org"
135     printf '%s:6:\n' "$FINGERPRINT" | gpg --quiet --batch --no-tty --import-ownertrust
136 }
137
138 add_gpgsm_home () {
139     test_require_external_prereq openssl
140
141     local fpr
142     [ -e "$GNUPGHOME/gpgsm.conf" ] && return
143     _gnupg_exit () { gpgconf --kill all 2>/dev/null || true; }
144     at_exit_function _gnupg_exit
145     mkdir -p -m 0700 "$GNUPGHOME"
146     openssl pkcs12 -export -passout pass: -inkey "$NOTMUCH_SRCDIR/test/smime/key+cert.pem" \
147         < "$NOTMUCH_SRCDIR/test/smime/test.crt" | \
148         gpgsm --batch --no-tty --no-common-certs-import --pinentry-mode=loopback --passphrase-fd 3 \
149               --disable-dirmngr --import  >"$GNUPGHOME"/import.log 2>&1 3<<<''
150     fpr=$(gpgsm --batch --list-key test_suite@notmuchmail.org | sed -n 's/.*fingerprint: //p')
151     echo "$fpr S relax" >> "$GNUPGHOME/trustlist.txt"
152     gpgsm --quiet --batch --no-tty --no-common-certs-import --disable-dirmngr --import < $NOTMUCH_SRCDIR/test/smime/ca.crt
153     echo "4D:E0:FF:63:C0:E9:EC:01:29:11:C8:7A:EE:DA:3A:9A:7F:6E:C1:0D S" >> "$GNUPGHOME/trustlist.txt"
154     printf '%s::1\n' include-certs disable-crl-checks | gpgconf --output /dev/null --change-options gpgsm
155     gpgsm --batch --no-tty --no-common-certs-import --pinentry-mode=loopback --passphrase-fd 3 \
156               --disable-dirmngr --import "$NOTMUCH_SRCDIR/test/smime/bob.p12" >>"$GNUPGHOME"/import.log 2>&1 3<<<''
157     test_debug "cat $GNUPGHOME/import.log"
158 }
159
160 # Each test should start with something like this, after copyright notices:
161 #
162 # test_description='Description of this test...
163 # This test checks if command xyzzy does the right thing...
164 # '
165 # . ./test-lib.sh || exit 1
166
167 color=maybe
168
169 while test "$#" -ne 0
170 do
171         case "$1" in
172         -d|--debug)
173                 debug=t; shift ;;
174         -i|--immediate)
175                 immediate=t; shift ;;
176         -h|--help)
177                 help=t; shift ;;
178         -v|--verbose)
179                 verbose=t; shift ;;
180         -q|--quiet)
181                 quiet=t; shift ;;
182         --with-dashes)
183                 with_dashes=t; shift ;;
184         --no-color)
185                 color=; shift ;;
186         --no-python)
187                 # noop now...
188                 shift ;;
189         --valgrind)
190                 valgrind=t; verbose=t; shift ;;
191         --tee)
192                 shift ;; # was handled already
193         *)
194                 echo "error: unknown test option '$1'" >&2; exit 1 ;;
195         esac
196 done
197
198 if test -n "$debug"; then
199         fmt_subtest () {
200                 printf -v $1 " %-4s" "[$((test_count - 1))]"
201         }
202 else
203         fmt_subtest () {
204                 printf -v $1 ''
205         }
206 fi
207
208 test -n "$COLORS_WITHOUT_TTY" || [ -t 1 ] || color=
209
210 if [ -n "$color" ] && [ "$ORIGINAL_TERM" != 'dumb' ] &&
211         tput -T "$ORIGINAL_TERM" -S <<<$'bold\nsetaf\nsgr0\n' >/dev/null 2>&1
212 then
213         color=t
214 else
215         color=
216 fi
217
218 if test -n "$color"
219 then
220         # _tput run in subshell (``) only
221         _tput () { exec tput -T "$ORIGINAL_TERM" "$@"; }
222         unset BOLD RED GREEN BROWN SGR0
223         say_color () {
224                 case "$1" in
225                         error)  b=${BOLD=`_tput bold`}
226                                 c=${RED=`_tput setaf 1`}   ;; # bold red
227                         skip)   b=${BOLD=`_tput bold`}
228                                 c=${GREEN=`_tput setaf 2`} ;; # bold green
229                         pass)   b= c=${GREEN=`_tput setaf 2`} ;; # green
230                         info)   b= c=${BROWN=`_tput setaf 3`} ;; # brown
231                         *) b= c=; test -n "$quiet" && return ;;
232                 esac
233                 f=$2
234                 shift 2
235                 sgr0=${SGR0=`_tput sgr0`}
236                 fmt_subtest st
237                 printf " ${b}${c}${f}${sgr0}${st}" "$@"
238         }
239 else
240         say_color() {
241                 test -z "$1" && test -n "$quiet" && return
242                 f=$2
243                 shift 2
244                 fmt_subtest st
245                 printf " ${f}${st}" "$@"
246         }
247 fi
248
249 error () {
250         say_color error "error: $*\n"
251         GIT_EXIT_OK=t
252         exit 1
253 }
254
255 say () {
256         say_color info "$*"
257 }
258
259 test "${test_description}" != "" ||
260 error "Test script did not set test_description."
261
262 if test "$help" = "t"
263 then
264         echo "Tests ${test_description}"
265         exit 0
266 fi
267
268 test_description_printed=
269 print_test_description () {
270         test -z "$test_description_printed" || return 0
271         echo
272         echo $this_test: "Testing ${test_description}"
273         test_description_printed=1
274 }
275 if [ -z "$NOTMUCH_TEST_QUIET" ]
276 then
277         print_test_description
278 fi
279
280 test_failure=0
281 test_count=0
282 test_fixed=0
283 test_broken=0
284 test_success=0
285
286 declare -a _exit_functions=()
287
288 at_exit_function () {
289         _exit_functions=($1 ${_exit_functions[@]/$1})
290 }
291
292 rm_exit_function () {
293         _exit_functions=(${_exit_functions[@]/$1})
294 }
295
296 _exit_common () {
297         code=$?
298         trap - EXIT
299         set +ex
300         for _fn in ${_exit_functions[@]}; do $_fn; done
301         rm -rf "$TEST_TMPDIR"
302 }
303
304 trap_exit () {
305         _exit_common
306         if test -n "$GIT_EXIT_OK"
307         then
308                 exit $code
309         else
310                 exec >&6
311                 say_color error '%-6s' FATAL
312                 echo " $test_subtest_name"
313                 echo
314                 echo "Unexpected exit while executing $0. Exit code $code."
315                 exit 1
316         fi
317 }
318
319 trap_signal () {
320         _exit_common
321         echo >&6 "FATAL: $0: interrupted by signal" $((code - 128))
322         exit $code
323 }
324
325 die () {
326         _exit_common
327         exec >&6
328         say_color error '%-6s' FATAL
329         echo " $*"
330         echo
331         echo "Unexpected exit while executing $0."
332         exit 1
333 }
334
335 GIT_EXIT_OK=
336 # Note: TEST_TMPDIR *NOT* exported!
337 TEST_TMPDIR=$(mktemp -d "${TMPDIR:-/tmp}/notmuch-test-$$.XXXXXX")
338 # Put GNUPGHOME in TMPDIR to avoid problems with long paths.
339 export GNUPGHOME="${TEST_TMPDIR}/gnupg"
340 trap 'trap_exit' EXIT
341 trap 'trap_signal' HUP INT TERM
342
343 # Add an existing, fixed corpus of email to the database.
344 #
345 # $1 is the corpus dir under corpora to add, using "default" if unset.
346 #
347 # The default corpus is based on about 50 messages from early in the
348 # history of the notmuch mailing list, which allows for reliably
349 # testing commands that need to operate on a not-totally-trivial
350 # number of messages.
351 add_email_corpus () {
352     local corpus
353     corpus=${1:-default}
354
355     rm -rf ${MAIL_DIR}
356     cp -a $NOTMUCH_SRCDIR/test/corpora/$corpus ${MAIL_DIR}
357     notmuch new >/dev/null || die "'notmuch new' failed while adding email corpus"
358 }
359
360 test_begin_subtest () {
361     if [ -n "$inside_subtest" ]; then
362         exec 1>&6 2>&7          # Restore stdout and stderr
363         error "bug in test script: Missing test_expect_equal in ${BASH_SOURCE[1]}:${BASH_LINENO[0]}"
364     fi
365     test_subtest_name="$1"
366     test_reset_state_
367     # Redirect test output to the previously prepared file descriptors
368     # 3 and 4 (see below)
369     if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
370     exec >&3 2>&4
371     inside_subtest=t
372 }
373
374 # Pass test if two arguments match
375 #
376 # Note: Unlike all other test_expect_* functions, this function does
377 # not accept a test name. Instead, the caller should call
378 # test_begin_subtest before calling this function in order to set the
379 # name.
380 test_expect_equal () {
381         local output expected testname
382         exec 1>&6 2>&7          # Restore stdout and stderr
383         if [ -z "$inside_subtest" ]; then
384                 error "bug in the test script: test_expect_equal without test_begin_subtest"
385         fi
386         inside_subtest=
387         test "$#" = 2 ||
388         error "bug in the test script: not 2 parameters to test_expect_equal"
389
390         output="$1"
391         expected="$2"
392         if ! test_skip "$test_subtest_name"
393         then
394                 if [ "$output" = "$expected" ]; then
395                         test_ok_
396                 else
397                         testname=$this_test.$test_count
398                         echo "$expected" > $testname.expected
399                         echo "$output" > $testname.output
400                         test_failure_ "$(diff -u $testname.expected $testname.output)"
401                 fi
402     fi
403 }
404
405 test_diff_file_ () {
406     local file1 file2 testname basename1 basename2
407     file1="$1"
408     file2="$2"
409     if ! test_skip "$test_subtest_name"
410     then
411         if diff -q "$file1" "$file2" >/dev/null ; then
412             test_ok_
413         else
414             testname=$this_test.$test_count
415             basename1=`basename "$file1"`
416             basename2=`basename "$file2"`
417             cp "$file1" "$testname.$basename1"
418             cp "$file2" "$testname.$basename2"
419             test_failure_ "$(diff -u "$testname.$basename1" "$testname.$basename2")"
420         fi
421     fi
422 }
423
424 # Like test_expect_equal, but takes two filenames.
425 test_expect_equal_file () {
426     exec 1>&6 2>&7              # Restore stdout and stderr
427     if [ -z "$inside_subtest" ]; then
428         error "bug in the test script: test_expect_equal_file without test_begin_subtest"
429     fi
430     inside_subtest=
431     test "$#" = 2 ||
432         error "bug in the test script: not 2 parameters to test_expect_equal_file"
433
434     test_diff_file_ "$1" "$2"
435 }
436
437 # Like test_expect_equal, but arguments are JSON expressions to be
438 # canonicalized before diff'ing.  If an argument cannot be parsed, it
439 # is used unchanged so that there's something to diff against.
440 test_expect_equal_json () {
441     local script output expected
442     # The test suite forces LC_ALL=C, but this causes Python 3 to
443     # decode stdin as ASCII.  We need to read JSON in UTF-8, so
444     # override Python's stdio encoding defaults.
445     script='import json, sys; json.dump(json.load(sys.stdin), sys.stdout, sort_keys=True, indent=4)'
446     output=$(echo "$1" | PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c "$script" \
447         || echo "$1")
448     expected=$(echo "$2" | PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c "$script" \
449         || echo "$2")
450     shift 2
451     test_expect_equal "$output" "$expected" "$@"
452 }
453
454 # Ensure that the argument is valid JSON data.
455 test_valid_json () {
456     PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c "import sys, json; json.load(sys.stdin)" <<<"$1"
457     test_expect_equal "$?" 0
458 }
459
460 # Sort the top-level list of JSON data from stdin.
461 test_sort_json () {
462     PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c \
463         "import sys, json; json.dump(sorted(json.load(sys.stdin)),sys.stdout)"
464 }
465
466 # test for json objects:
467 # read the source of test/json_check_nodes.py (or the output when
468 # invoking it without arguments) for an explanation of the syntax.
469 test_json_nodes () {
470         local output
471         exec 1>&6 2>&7          # Restore stdout and stderr
472         if [ -z "$inside_subtest" ]; then
473                 error "bug in the test script: test_json_eval without test_begin_subtest"
474         fi
475         inside_subtest=
476         test "$#" > 0 ||
477             error "bug in the test script: test_json_nodes needs at least 1 parameter"
478
479         if ! test_skip "$test_subtest_name"
480         then
481             output=$(PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -B "$NOTMUCH_SRCDIR"/test/json_check_nodes.py "$@")
482                 if [ "$?" = 0 ]
483                 then
484                         test_ok_
485                 else
486                         test_failure_ "$output"
487                 fi
488         fi
489 }
490
491 NOTMUCH_NEW () {
492     notmuch new "${@}" | grep -v -E -e '^Processed [0-9]*( total)? file|Found [0-9]* total file'
493 }
494
495 NOTMUCH_DUMP_TAGS () {
496     # this relies on the default format being batch-tag, otherwise some tests will break
497     notmuch dump --include=tags "${@}" | sed '/^#/d' | sort
498 }
499
500 notmuch_drop_mail_headers () {
501     $NOTMUCH_PYTHON -c '
502 import email, sys
503 msg = email.message_from_file(sys.stdin)
504 for hdr in sys.argv[1:]: del msg[hdr]
505 print(msg.as_string(False))
506 ' "$@"
507 }
508
509 notmuch_debug_sanitize () {
510     grep -v '^D.:'
511 }
512
513 notmuch_exception_sanitize () {
514     perl -pe 's/(A Xapian exception occurred at .*[.]cc?):([0-9]*)/\1:XXX/'
515 }
516
517 notmuch_search_sanitize () {
518     notmuch_debug_sanitize | perl -pe 's/("?thread"?: ?)("?)................("?)/\1\2XXX\3/'
519 }
520
521 notmuch_search_files_sanitize () {
522     notmuch_dir_sanitize
523 }
524
525 notmuch_dir_sanitize () {
526     sed -e "s,$MAIL_DIR,MAIL_DIR," -e "s,${PWD},CWD,g" "$@"
527 }
528
529 NOTMUCH_SHOW_FILENAME_SQUELCH='s,filename:.*/mail,filename:/XXX/mail,'
530 notmuch_show_sanitize () {
531     sed -e "$NOTMUCH_SHOW_FILENAME_SQUELCH"
532 }
533 notmuch_show_sanitize_all () {
534     notmuch_debug_sanitize | \
535     sed \
536         -e 's| filename:.*| filename:XXXXX|' \
537         -e 's| id:[^ ]* | id:XXXXX |' | \
538         notmuch_date_sanitize
539 }
540
541 notmuch_json_show_sanitize () {
542     sed \
543         -e 's|"id": "[^"]*",|"id": "XXXXX",|g' \
544         -e 's|"Date": "Fri, 05 Jan 2001 [^"]*0000"|"Date": "GENERATED_DATE"|g' \
545         -e 's|"filename": "signature.asc",||g' \
546         -e 's|"filename": \["/[^"]*"\],|"filename": \["YYYYY"\],|g' \
547         -e 's|"timestamp": 97.......|"timestamp": 42|g' \
548         -e 's|"content-length": [1-9][0-9]*|"content-length": "NONZERO"|g'
549 }
550
551 notmuch_emacs_error_sanitize () {
552     local command
553     command=$1
554     shift
555     for file in "$@"; do
556         echo "=== $file ==="
557         notmuch_debug_sanitize < "$file"
558     done | sed \
559         -e '/^$/d' \
560         -e '/^\[.*\]$/d' \
561         -e "s|^\(command: \)\{0,1\}/.*/$command|\1YYY/$command|"
562 }
563
564 notmuch_date_sanitize () {
565     sed \
566         -e 's/^Date: Fri, 05 Jan 2001 .*0000/Date: GENERATED_DATE/'
567 }
568
569 notmuch_uuid_sanitize () {
570     sed 's/[0-9a-f]\{8\}-[0-9a-f]\{4\}-[0-9a-f]\{4\}-[0-9a-f]\{4\}-[0-9a-f]\{12\}/UUID/g'
571 }
572
573 notmuch_built_with_sanitize () {
574     sed 's/^built_with[.]\(.*\)=.*$/built_with.\1=something/'
575 }
576
577 notmuch_config_sanitize () {
578     notmuch_dir_sanitize | notmuch_built_with_sanitize
579 }
580
581 notmuch_show_part () {
582     awk '/^\014part}/{ f=0 }; { if (f) { print $0 } } /^\014part{ ID: '"$1"'/{ f=1 }'
583 }
584
585 # End of notmuch helper functions
586
587 # Use test_set_prereq to tell that a particular prerequisite is available.
588 #
589 # The prerequisite can later be checked for by using test_have_prereq.
590 #
591 # The single parameter is the prerequisite tag (a simple word, in all
592 # capital letters by convention).
593
594 test_set_prereq () {
595         satisfied="$satisfied$1 "
596 }
597 satisfied=" "
598
599 test_have_prereq () {
600         case $satisfied in
601         *" $1 "*)
602                 : yes, have it ;;
603         *)
604                 ! : nope ;;
605         esac
606 }
607
608 declare -A test_missing_external_prereq_
609 declare -A test_subtest_missing_external_prereq_
610
611 # declare prerequisite for the given external binary
612 test_declare_external_prereq () {
613         local binary
614         binary="$1"
615         test "$#" = 2 && name=$2 || name="$binary(1)"
616
617         if ! hash $binary 2>/dev/null; then
618                 test_missing_external_prereq_["${binary}"]=t
619                 eval "
620 $binary () {
621         test_subtest_missing_external_prereq_[\"${name}\"]=t
622         false
623 }"
624         fi
625 }
626
627 # Explicitly require external prerequisite.  Useful when binary is
628 # called indirectly (e.g. from emacs).
629 # Returns success if dependency is available, failure otherwise.
630 test_require_external_prereq () {
631         local binary
632         binary="$1"
633         if [[ ${test_missing_external_prereq_["${binary}"]} == t ]]; then
634                 # dependency is missing, call the replacement function to note it
635                 eval "$binary"
636         else
637                 true
638         fi
639 }
640
641 # You are not expected to call test_ok_ and test_failure_ directly, use
642 # the text_expect_* functions instead.
643
644 test_ok_ () {
645         if test "$test_subtest_known_broken_" = "t"; then
646                 test_known_broken_ok_
647                 return
648         fi
649         test_success=$(($test_success + 1))
650         if test -n "$NOTMUCH_TEST_QUIET"; then
651                 return 0
652         fi
653         say_color pass "%-6s" "PASS"
654         echo " $test_subtest_name"
655 }
656
657 test_failure_ () {
658         print_test_description
659         if test "$test_subtest_known_broken_" = "t"; then
660                 test_known_broken_failure_ "$@"
661                 return
662         fi
663         test_failure=$(($test_failure + 1))
664         test_failure_message_ "FAIL" "$test_subtest_name" "$@"
665         test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
666         return 1
667 }
668
669 test_failure_message_ () {
670         say_color error "%-6s" "$1"
671         echo " $2"
672         shift 2
673         if [ "$#" != "0" ]; then
674                 echo "$@" | sed -e 's/^/        /'
675         fi
676         if test "$verbose" != "t"; then cat test.output; fi
677 }
678
679 test_known_broken_ok_ () {
680         test_reset_state_
681         test_fixed=$(($test_fixed+1))
682         say_color pass "%-6s" "FIXED"
683         echo " $test_subtest_name"
684 }
685
686 test_known_broken_failure_ () {
687         test_reset_state_
688         test_broken=$(($test_broken+1))
689         if [ -z "$NOTMUCH_TEST_QUIET" ]; then
690                 test_failure_message_ "BROKEN" "$test_subtest_name" "$@"
691         else
692                 test_failure_message_ "BROKEN" "$test_subtest_name"
693         fi
694         return 1
695 }
696
697 test_debug () {
698         test "$debug" = "" || eval "$1"
699 }
700
701 test_run_ () {
702         test_cleanup=:
703         if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
704         eval >&3 2>&4 "$1"
705         eval_ret=$?
706         eval >&3 2>&4 "$test_cleanup"
707         return 0
708 }
709
710 test_skip () {
711         test_count=$(($test_count+1))
712         to_skip=
713         for skp in $NOTMUCH_SKIP_TESTS
714         do
715                 case $this_test.$test_count in
716                 $skp)
717                         to_skip=t
718                         break
719                 esac
720                 case $this_test_bare.$test_count in
721                 $skp)
722                         to_skip=t
723                         break
724                 esac
725         done
726         case "$to_skip" in
727         t)
728                 test_report_skip_ "$@"
729                 ;;
730         *)
731                 test_check_missing_external_prereqs_ "$@"
732                 ;;
733         esac
734 }
735
736 test_check_missing_external_prereqs_ () {
737         if [[ ${#test_subtest_missing_external_prereq_[@]} != 0 ]]; then
738                 say_color skip >&1 "missing prerequisites: "
739                 echo ${!test_subtest_missing_external_prereq_[@]} >&1
740                 test_report_skip_ "$@"
741         else
742                 false
743         fi
744 }
745
746 test_report_skip_ () {
747         test_reset_state_
748         say_color skip >&3 "skipping test:"
749         echo " $@" >&3
750         say_color skip "%-6s" "SKIP"
751         echo " $1"
752 }
753
754 test_subtest_known_broken () {
755         test_subtest_known_broken_=t
756 }
757
758 test_expect_success () {
759         exec 1>&6 2>&7          # Restore stdout and stderr
760         if [ -z "$inside_subtest" ]; then
761                 error "bug in the test script: test_expect_success without test_begin_subtest"
762         fi
763         inside_subtest=
764         test "$#" = 1 ||
765         error "bug in the test script: not 1 parameters to test_expect_success"
766
767         if ! test_skip "$test_subtest_name"
768         then
769                 test_run_ "$1"
770                 run_ret="$?"
771                 # test_run_ may update missing external prerequisites
772                 test_check_missing_external_prereqs_ "$test_subtest_name" ||
773                 if [ "$run_ret" = 0 -a "$eval_ret" = 0 ]
774                 then
775                         test_ok_
776                 else
777                         test_failure_ "$1"
778                 fi
779         fi
780 }
781
782 test_expect_code () {
783         exec 1>&6 2>&7          # Restore stdout and stderr
784         if [ -z "$inside_subtest" ]; then
785                 error "bug in the test script: test_expect_code without test_begin_subtest"
786         fi
787         inside_subtest=
788         test "$#" = 2 ||
789         error "bug in the test script: not 2 parameters to test_expect_code"
790
791         if ! test_skip "$test_subtest_name"
792         then
793                 test_run_ "$2"
794                 run_ret="$?"
795                 # test_run_ may update missing external prerequisites,
796                 test_check_missing_external_prereqs_ "$test_subtest_name" ||
797                 if [ "$run_ret" = 0 -a "$eval_ret" = "$1" ]
798                 then
799                         test_ok_
800                 else
801                         test_failure_ "exit code $eval_ret, expected $1" "$2"
802                 fi
803         fi
804 }
805
806 # This is not among top-level (test_expect_success)
807 # but is a prefix that can be used in the test script, like:
808 #
809 #       test_expect_success 'complain and die' '
810 #           do something &&
811 #           do something else &&
812 #           test_must_fail git checkout ../outerspace
813 #       '
814 #
815 # Writing this as "! git checkout ../outerspace" is wrong, because
816 # the failure could be due to a segv.  We want a controlled failure.
817
818 test_must_fail () {
819         "$@"
820         test $? -gt 0 -a $? -le 129 -o $? -gt 192
821 }
822
823 # test_cmp is a helper function to compare actual and expected output.
824 # You can use it like:
825 #
826 #       test_expect_success 'foo works' '
827 #               echo expected >expected &&
828 #               foo >actual &&
829 #               test_cmp expected actual
830 #       '
831 #
832 # This could be written as either "cmp" or "diff -u", but:
833 # - cmp's output is not nearly as easy to read as diff -u
834 # - not all diff versions understand "-u"
835
836 test_cmp () {
837         $GIT_TEST_CMP "$@"
838 }
839
840 # This function can be used to schedule some commands to be run
841 # unconditionally at the end of the test to restore sanity:
842 #
843 #       test_expect_success 'test core.capslock' '
844 #               git config core.capslock true &&
845 #               test_when_finished "git config --unset core.capslock" &&
846 #               hello world
847 #       '
848 #
849 # That would be roughly equivalent to
850 #
851 #       test_expect_success 'test core.capslock' '
852 #               git config core.capslock true &&
853 #               hello world
854 #               git config --unset core.capslock
855 #       '
856 #
857 # except that the greeting and config --unset must both succeed for
858 # the test to pass.
859
860 test_when_finished () {
861         test_cleanup="{ $*
862                 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
863 }
864
865 test_done () {
866         GIT_EXIT_OK=t
867         test_results_dir="$TEST_DIRECTORY/test-results"
868         mkdir -p "$test_results_dir"
869         test_results_path="$test_results_dir/$this_test"
870
871         printf %s\\n \
872                 "success $test_success" \
873                 "fixed $test_fixed" \
874                 "broken $test_broken" \
875                 "failed $test_failure" \
876                 "total $test_count" \
877             > $test_results_path
878
879         [ -n "$EMACS_SERVER" ] && test_emacs '(kill-emacs)'
880
881         if [ "$test_failure" = "0" ]; then
882             if [ "$test_broken" = "0" ]; then
883                 rm -rf "$remove_tmp"
884             fi
885             exit 0
886         else
887             exit 1
888         fi
889 }
890
891 test_python () {
892     # Note: if there is need to print debug information from python program,
893     # use stdout = os.fdopen(6, 'w') or stderr = os.fdopen(7, 'w')
894     PYTHONPATH="$NOTMUCH_SRCDIR/bindings/python${PYTHONPATH:+:$PYTHONPATH}" \
895         $NOTMUCH_PYTHON -B - > OUTPUT
896 }
897
898 test_C () {
899     local exec_file test_file
900     exec_file="test${test_count}"
901     test_file="${exec_file}.c"
902     cat > ${test_file}
903     ${TEST_CC} ${TEST_CFLAGS} -I${NOTMUCH_SRCDIR}/test -I${NOTMUCH_SRCDIR}/lib -o ${exec_file} ${test_file} -L${NOTMUCH_BUILDDIR}/lib/ -lnotmuch -ltalloc
904     echo "== stdout ==" > OUTPUT.stdout
905     echo "== stderr ==" > OUTPUT.stderr
906     ./${exec_file} "$@" 1>>OUTPUT.stdout 2>>OUTPUT.stderr
907     notmuch_dir_sanitize OUTPUT.stdout OUTPUT.stderr | notmuch_exception_sanitize | notmuch_debug_sanitize > OUTPUT
908 }
909
910 make_shim () {
911     local base_name test_file shim_file
912     base_name="$1"
913     test_file="${base_name}.c"
914     shim_file="${base_name}.so"
915     cat > ${test_file}
916     ${TEST_CC} ${TEST_CFLAGS} ${TEST_SHIM_CFLAGS} -I${NOTMUCH_SRCDIR}/test -I${NOTMUCH_SRCDIR}/lib -o ${shim_file} ${test_file} ${TEST_SHIM_LDFLAGS}
917 }
918
919 notmuch_with_shim () {
920     local base_name shim_file
921     base_name="$1"
922     shift
923     shim_file="${base_name}.so"
924     LD_PRELOAD=${LD_PRELOAD:+:$LD_PRELOAD}:./${shim_file} notmuch-shared "$@"
925 }
926
927 # Creates a script that counts how much time it is executed and calls
928 # notmuch.  $notmuch_counter_command is set to the path to the
929 # generated script.  Use notmuch_counter_value() function to get the
930 # current counter value.
931 notmuch_counter_reset () {
932         notmuch_counter_command="$TMP_DIRECTORY/notmuch_counter"
933         if [ ! -x "$notmuch_counter_command" ]; then
934                 notmuch_counter_state_path="$TMP_DIRECTORY/notmuch_counter.state"
935                 cat >"$notmuch_counter_command" <<EOF || return
936 #!/bin/sh
937
938 read count < "$notmuch_counter_state_path"
939 echo \$((count + 1)) > "$notmuch_counter_state_path"
940
941 exec notmuch "\$@"
942 EOF
943                 chmod +x "$notmuch_counter_command" || return
944         fi
945
946         echo 0 > "$notmuch_counter_state_path"
947 }
948
949 # Returns the current notmuch counter value.
950 notmuch_counter_value () {
951         if [ -r "$notmuch_counter_state_path" ]; then
952                 read count < "$notmuch_counter_state_path"
953         else
954                 count=0
955         fi
956         echo $count
957 }
958
959 test_reset_state_ () {
960         test -z "$test_init_done_" && test_init_
961
962         test_subtest_known_broken_=
963         test_subtest_missing_external_prereq_=()
964 }
965
966 # called once before the first subtest
967 test_init_ () {
968         test_init_done_=t
969
970         # skip all tests if there were external prerequisites missing during init
971         test_check_missing_external_prereqs_ "all tests in $this_test" && test_done
972 }
973
974
975 # Where to run the tests
976 TEST_DIRECTORY=$NOTMUCH_BUILDDIR/test
977
978 . "$NOTMUCH_SRCDIR/test/test-lib-common.sh" || exit 1
979
980 # Use -P to resolve symlinks in our working directory so that the cwd
981 # in subprocesses like git equals our $PWD (for pathname comparisons).
982 cd -P "$TMP_DIRECTORY" || error "Cannot set up test environment"
983
984 if test "$verbose" = "t"
985 then
986         exec 4>&2 3>&1
987 else
988         exec 4>test.output 3>&4
989 fi
990
991 for skp in $NOTMUCH_SKIP_TESTS
992 do
993         to_skip=
994         for skp in $NOTMUCH_SKIP_TESTS
995         do
996                 case "$this_test" in
997                 $skp)
998                         to_skip=t
999                         break
1000                 esac
1001                 case "$this_test_bare" in
1002                 $skp)
1003                         to_skip=t
1004                         break
1005                 esac
1006         done
1007         case "$to_skip" in
1008         t)
1009                 say_color skip >&3 "skipping test $this_test altogether"
1010                 say_color skip "skip all tests in $this_test"
1011                 test_done
1012         esac
1013 done
1014
1015 # Provide an implementation of the 'yes' utility
1016 yes () {
1017         if test $# = 0
1018         then
1019                 y=y
1020         else
1021                 y="$*"
1022         fi
1023
1024         while echo "$y"
1025         do
1026                 :
1027         done
1028 }
1029
1030 # Fix some commands on Windows
1031 case $(uname -s) in
1032 *MINGW*)
1033         # Windows has its own (incompatible) sort and find
1034         sort () {
1035                 /usr/bin/sort "$@"
1036         }
1037         find () {
1038                 /usr/bin/find "$@"
1039         }
1040         sum () {
1041                 md5sum "$@"
1042         }
1043         # git sees Windows-style pwd
1044         pwd () {
1045                 builtin pwd -W
1046         }
1047         # no POSIX permissions
1048         # backslashes in pathspec are converted to '/'
1049         # exec does not inherit the PID
1050         ;;
1051 *)
1052         test_set_prereq POSIXPERM
1053         test_set_prereq BSLASHPSPEC
1054         test_set_prereq EXECKEEPSPID
1055         ;;
1056 esac
1057
1058 test -z "$NO_PERL" && test_set_prereq PERL
1059 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1060
1061 # test whether the filesystem supports symbolic links
1062 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1063 rm -f y
1064
1065 # declare prerequisites for external binaries used in tests
1066 test_declare_external_prereq dtach
1067 test_declare_external_prereq emacs
1068 test_declare_external_prereq ${TEST_EMACSCLIENT}
1069 test_declare_external_prereq ${TEST_GDB}
1070 test_declare_external_prereq gpg
1071 test_declare_external_prereq openssl
1072 test_declare_external_prereq gpgsm
1073 test_declare_external_prereq ${NOTMUCH_PYTHON}
1074 test_declare_external_prereq xapian-metadata
1075 test_declare_external_prereq xapian-delve